/*********************************\
* HackMan 1.0 - Gregory Magarshak *
* Coded for Allegro SizeHack 2000 *
* Around the time of my birthday. *
* I've turned 17 this year... :-) *
\*********************************/

/* Note: I included comments for clarity.
 * Please make sure neither /*...* / nor //...
 * Comments count towards the size limit.
 * Note also this might not compile in a
 * Regular C compiler such as UNIX acc.
 */

#include "allegro.h"
#include "math.h"
#define SW 640 // screen width
#define SH 480 // screen height
#define SD 16 // color depth
#define LH 16 // level height
#define MapTile(x_,y_) ((short*)(Maps->line[(y_)+level*LH]))[(x_)] // Map Tile
#ifndef END_OF_MAIN
#define END_OF_MAIN()
#endif

// Bitmaps for the characters & levels
BITMAP *HackMan, *Ghost, *Wall, *Maps, *Menu,
       *HackTemp, *HackTemp2, *HackTemp3;
int HackPower=0, HackPTime=0, HackPFade=200, HackLives=3;
int CC = 5; // # of frames for animation, determines smoothness
int GameSpeed = 200; // hmm, what could this be?
// Positions for the characters & levels
int hx, hy, phx, phy, gx[4], gy[4], pgx[4], pgy[4], level=0;
int gexist[4];
// Timing
float chronon, freezetime=FALSE, hc=0, gc[4]={0};
// Let's make a point system
int Points=0;
// Let's get lucky sometime :)
int PowerOdds=800; // approximate odds of a powerup appearing
// Offscreen buffer
BITMAP *offscreen;
// Other
MIDI *sndPower;

void setframes(); // Determines how smooth animation can be on this comp
void chronos(); // Makes chronons depend on actual time :)
int draw(BITMAP*);   // Draw function -- draws the scene
                     // (and due to memory constraints does other stuff)
int loadlevel(); // LoadLevel function - loads current level
int ghostai(); // The brains of ghosts... icky :)
int gameover();
int menu(char *Title, int Resume); // Shows menu, pauses game
int win(); // Lets you win, hehe :)

int main()
{
   int i, j, k;
   int mdown=0;

   allegro_init();
   install_keyboard();
   install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);
   i_love_bill = TRUE; // Not really, but this helps :)
   install_timer();

   printf("HackMan 2000\n");
   printf("Initializing...\n");

   set_color_depth(SD);
   set_gfx_mode(GFX_AUTODETECT, SW, SH, 0, 0);
   set_trans_blender(0, 0, 0, 170);
   set_volume(255, 255);

   /* Make Menu */
   offscreen = create_bitmap(SW, SH);
   Menu = create_bitmap(200, 150);

   /* Load HackMan */
   HackMan = load_bmp("hackman.bmp", NULL);
   HackTemp = create_bitmap(32, 32);
   HackTemp2 = create_bitmap(32, 32);
   HackTemp3 = create_bitmap(32, 32);

   /* Load Ghosts */
   Ghost = load_bmp("ghost.bmp", NULL);

   /* Load Wall BMP */
   Wall = load_bitmap("Wall.bmp", NULL);

   /* Load Levels */
   Maps = load_bitmap("Maps.bmp", NULL);
   level = 0;
   loadlevel(); // begin level 0 :)

   /* Load Sounds */
   sndPower = load_midi("im.mid");

   /* Calculate the Speed */
   setframes();

   play_midi(sndPower, 0);
   draw(screen);
   menu("* M E N U *", 0);

   /* Begin time */
   freezetime = 1;
   install_int(chronos, GameSpeed/CC);

   /* Game Loop */
   while (1)
   {
      if (!freezetime) chronon++;
      freezetime = 1;
      if (chronon > hc+CC)
      {
         phx=hx; phy=hy;
         if (MapTile(hx, hy) == 5)
         {
            HackLives++; // powerup
            HackPower=1; // special effect :)
            HackPTime = chronon;
            Points+=10;
            play_midi(sndPower, 0);
            MapTile(phx, phy) = 2;
         }
         else if (MapTile(phx, phy) == 0)
         {
            MapTile(phx, phy) = 2;
            Points++;
         }
         if (chronon - HackPTime > HackPFade) HackPower = 0;
         if (key[KEY_UP] && hy>0 && MapTile(hx, hy-1)!=-1)
            {hc = chronon; hy--;}
         if (key[KEY_DOWN] && hy<14 && MapTile(hx, hy+1)!=-1)
            {hc = chronon; hy++;}
         if (key[KEY_RIGHT] && hx<19 && MapTile(hx+1, hy)!=-1)
            {hc = chronon; hx++;}
         if (key[KEY_LEFT] && hx>0 && MapTile(hx-1, hy)!=-1)
            {hc = chronon; hx--;}
         if (key[KEY_PGUP]) { level++; if (loadlevel() == -1) level--; }
         if (key[KEY_PGDN]) { if (level > 0) level--; loadlevel(); };
      }
      if (key[KEY_SPACE] || key[KEY_M] || key[KEY_ESC]) mdown=1;
      if (!key[KEY_SPACE] && !key[KEY_M] && mdown)
      {
         menu("* M E N U *", 1);
         mdown = 0;
      }
      i = ghostai();
      if (i == -20)
         menu("* INVALID LEVEL *", 0);
      i = draw(screen);
      if (i == 1) {
         level++; if (loadlevel()==-1) { level--; win(); }
      }
      else if (i < 0 && i >= -10)
         if (HackPower) { gexist[i+10] = 0; Points+=25; }
         else gameover();
      else if (i == -20)
         menu("* INVALID LEVEL *", 0);
      if (rand() % PowerOdds == 5)
         // we're generous, drop a powerup in an empty location
         for (i=0; i<200; i++)
         {
            j = rand()%20; k = rand()%15;
            if (MapTile(j, k) == 2)
            {
               MapTile(j, k) = 5;
               break;
            }
         }
   }

   allegro_exit();
   return 0;
}
END_OF_MAIN()

/* Function for setspeed */
void countchron()
{
   draw(screen);
   chronon++;
}

void setframes()
{
   chronon = 0;
   rest_callback(GameSpeed, countchron);
   CC = chronon;
   chronon = 0;
}

void chronos()
{
   freezetime = 0; // allow time to update
}

int draw(BITMAP *scr)
{
   int i, j, x, y, xx, yy, eater=-1, coins=0, lvlok=0;
   static int mouthcol=0, brightpink, lipcol=0, tempcol=0,
          coincol, coincol2, hacktint=0, hacktintstep=10,
          dirx=1, frames=0, angle=0;

   brightpink = makecol(255, 0, 255);
   coincol = makecol(150, 150, 0);
   coincol2 = makecol(255, 255, 0);

   clear(offscreen);
   for (i=0; i<20; i++)
       for (j=0; j<15; j++)
           switch (MapTile(i, j))
           {
            case -1:
              draw_sprite(offscreen, Wall, i*32, j*32);
              break;
            case 0:
              circlefill(offscreen, i*32+16, j*32+16, 4, coincol);
              circlefill(offscreen, i*32+16, j*32+16, 2, coincol2);
              coins++;
            case 2:
              lvlok = 1;
              break;
            case 5:
              stretch_sprite(offscreen, HackMan, i*32+8, j*32+8, 16, 16);
              lvlok = 1;
              break;
           }

   if (!lvlok) return -20;

   /* Animating the HackMan */
   if (!frames) frames = 10;
   frames--;
   if (!mouthcol) mouthcol = getpixel(HackMan, 25, 25);
   if (!lipcol) lipcol = brightpink;//getpixel(HackMan, 25, 20);
   if (frames == 5)
   {
      if (tempcol==0 || tempcol==lipcol) tempcol = mouthcol;
      else if (tempcol==mouthcol) tempcol = lipcol;
      floodfill(HackMan, 25, 25, tempcol); // fast enough
   }

   /* Moving the HackMan */
   x = (phx+(hx-phx)*(chronon-hc)/CC)*32;
   y = (phy+(hy-phy)*(chronon-hc)/CC)*32;
   clear_to_color(HackTemp, brightpink); //fast enough
   clear_to_color(HackTemp3, brightpink);
   if (hx<phx) dirx = -1;           // establish horizontal direction
   else if (hx>phx) dirx = 1;       // establish vertical direction
   if (angle) angle-=angle/abs(angle)*8; // angle goes to 0 if unchecked
   if (dirx == -1)
   {
      draw_sprite_h_flip(HackTemp, HackMan, 0, 0);
      if (hy>phy) angle = -32;
      else if (hy<phy) angle = 64;
   }
   else if (dirx == 1)
   {
      draw_sprite(HackTemp, HackMan, 0, 0);
      if (hy>phy) angle = 32;
      else if (hy<phy) angle = -64;
   }
   clear_to_color(HackTemp2, brightpink); //fast enough
   rotate_sprite(HackTemp2, HackTemp, 0, 0, angle<<16);
   if (HackPower)
   {
      hacktint += hacktintstep;
      if (hacktint>255) { hacktintstep = -hacktintstep; hacktint=255; }
      if (hacktint<0) { hacktintstep = -hacktintstep; hacktint=0; }
   }
   draw_gouraud_sprite (HackTemp3, HackTemp2, 0, 0,
                       255, 255-hacktint, 255, hacktint);
   if (HackPower)
      draw_trans_sprite(offscreen, HackTemp3, x, y);
   else
      draw_sprite(offscreen, HackTemp3, x, y);

   /* Moving the ghosts */
   for (i=0; i<4; i++)
   {
       if (!gexist[i]) continue;
       xx = (pgx[i]+(gx[i]-pgx[i])*((chronon-gc[i])/CC))*32;
       yy = (pgy[i]+(gy[i]-pgy[i])*((chronon-gc[i])/CC))*32;
       if (HackPower)
          draw_trans_sprite(offscreen, Ghost, xx, yy);
       else
          draw_gouraud_sprite(offscreen, Ghost, xx, yy, 255, 255, 0, 255);
       /* Collision between ghost and hackman */
       if (xx < x+18 && x < xx+18 && yy < y+18 && y < yy+18) eater=i;
   }

   /* Update the stats */
   textprintf(offscreen, font, 0, 0, 65535,
              "Lives Left: %d  Level: %d  Points: %d", HackLives, level+1, Points);

   //draw_trans_sprite(offscreen, Stats, 0, 0);
   blit(offscreen, scr, 0, 0, 0, 0, SW, SH);
   if (eater>=0) return eater-10;
   if (coins==0) return 1;
   return 0;
}

int loadlevel()
{
   int i, tempx=0, tempy=0;
   if (level * LH + LH > Maps->h) return -1;
   chronon=0;
   /* Get HackMan's Position In Level */
   hy = 0;
   for (i=0; i<4; i++)
       if (MapTile(i, 15) == -1) hy+=pow(2, 3-i);
   hx = 0;
   for (i=0; i<5; i++)
       if (MapTile(4+i, 15) == -1) hx+=pow(2, 4-i);
   hc = 0;
   HackPower = 0;
   /* Get Powerup's Position In Level */
   for (i=0; i<4; i++)
       if (MapTile(9+i, 15) == -1) tempy+=pow(2, 3-i);
   for (i=0; i<5; i++)
       if (MapTile(13+i, 15) == -1) tempx+=pow(2, 4-i);
   if (MapTile(tempx, tempy) == 0) MapTile(tempx, tempy) = 5;
   /* Set Ghosts' Positions In Level */
   gx[0] = gx[1] = 1;
   gy[0] = gy[2] = 1;
   gx[2] = gx[3] = 18;
   gy[1] = gy[3] = 13;
   gc[0] = gc[1] = gc[2] = gc[3] = 0;
   for (i=0; i<4; i++)
       gexist[i] = 1;
   /* Let's say Power Fade is function of level number */
   HackPFade = 200 - level * 10;
   return level;
}

int ghostai()
{
   int i, temp, getout=0;
   static dirx[4]={0}, diry[4]={0}, lastdirx[4], lastdiry[5];
   srand(rawclock());
   for (i=0; i<4; i++)
   {
       if (chronon > gc[i] + CC || chronon < 2)
       {
           temp=0;
           if (MapTile(gx[i]+1, gy[i])!=-1) temp++;
           if (MapTile(gx[i], gy[i]+1)!=-1) temp++;
           if (MapTile(gx[i]-1, gy[i])!=-1) temp++;
           if (MapTile(gx[i], gy[i]-1)!=-1) temp++;
           if (chronon<2 || // start of level
               MapTile(gx[i]+dirx[i],
                       gy[i]+diry[i])==-1 || // run into wall
               temp > 2) // reach intersection
           {
              do {
                  dirx[i] = rand()%3-1;
                  diry[i] = rand()%3-1;
                  getout++;
                  if (getout>100000)
                     return -20;
              } while (MapTile(gx[i]+dirx[i], gy[i]+diry[i])==-1 || // wall
                       (dirx[i]==0 && diry[i]==0) || // same spot
                       (temp>2 &&               // we're at intersection,
                       dirx[i]==-lastdirx[i] && // we've got more choices
                       dirx[i]==-lastdiry[i])); // than going back, COME ON! ;)
           }
           lastdirx[i] = dirx[i];
           lastdiry[i] = diry[i];
           pgx[i] = gx[i];
           pgy[i] = gy[i];
           gx[i] += dirx[i];
           gy[i] += diry[i];
           gc[i] = chronon;
       }
   }
   return 0;
}

int gameover()
{
   play_midi(sndPower, 0);
   HackLives--;
   if (HackLives == 0)
   {
      menu("* Game Over *", 0);
      return 1;
   }
   loadlevel();
   return 0;
}

int win()
{
      menu("* YOU WIN! *", 0);
      return 0;
}

int menu(char *Title, int Resume)
{
   /* Game Paused or Over */
   int userkey, handled=0, i;
   static BITMAP *Menu2=0;
   if (!Menu2) Menu2 = create_bitmap(Menu->w, Menu->h);
   clear(Menu);
   textprintf_centre(Menu, font, Menu->w/2, 20, 65535, Title);
   textprintf_centre(Menu, font, Menu->w/2, 40, 65535, "(N)ew Game");
   if (Resume)
   textprintf_centre(Menu, font, Menu->w/2, 50, 65535, "(R)esume Game");
   textprintf_centre(Menu, font, Menu->w/2, 60, 65535, "(Q)uit");
   for (i=0; i<=Menu->w; i+=20)
   {
         clear_to_color(Menu2, makecol(255, 0, 255));
         draw(offscreen);
         stretch_blit(Menu, Menu2, 0, 0, Menu->w, Menu->h,
                      (Menu2->w-i)/2, 0, i, Menu->h);
         draw_trans_sprite(offscreen, Menu2,
                     (offscreen->w - Menu2->w)/2,
                     (offscreen->h - Menu2->h)/2);
         blit (offscreen, screen, 0, 0, 0, 0, SW, SH);
   }
   clear_keybuf();
   while (!handled)
   {
      userkey = readkey() >> 8;
      switch (userkey)
      {
         case KEY_N:
              level = 0;
              destroy_bitmap(Maps);
              HackLives = 3;
              Points = 0;
              Maps = load_bitmap("Maps.bmp", NULL);
              loadlevel();
              handled = 1;
              break;
         case KEY_R:
              if (Resume) handled = 1;
              break;
         case KEY_Q:
              exit (0);
      }
   }
}
